 -- --------------------------------------------------------------------------- --
 -- --           incognize script pack #1 by  !Blob!/incognize '2000         -- --
 -- --                                                                       -- --
 -- --                                 * * *                                 -- --
 -- --                                                                       -- --
 -- --                         Features in ver. 1.0.0:                       -- --
 -- --  # Reset scene without asking;                                        -- --
 -- --  # Bulid fog, camera & ground (many scenes start with this);          -- --
 -- --  # Save/export/load/import - four things in two buttons better than   -- --
 -- --     the standart MAX functions; This feature is best useful, when you -- --
 -- --     exploring a pack of models, where some are '*.max', and others    -- --
 -- --     are '*.3ds', or other formats...                                  -- --
 -- --  # Check the network rendering mode...                                -- --
 -- --  # Check the version of MAX - sometimes you don't know what ver. of   -- --
 -- --    MAX you have!                                                      -- --
 -- --  # BEST THING: You can load the plug-ins when the 3DS MAX is running! -- --
 -- --  # Button that is clearing the image file bitmap cashes - it means    -- --
 -- --     that you may free from 10MB memory in simple scenes to more if    -- --
 -- --     you are working at the very big scenes...                         -- --
 -- --  # Exit button :)))                                                   -- --
 -- --                                                                       -- --
 -- --                                 * * *                                 -- --
 -- --                                                                       -- --
 -- --   This is our first script so thats why is so simple. I (!Blob!)      -- --
 -- --    started to wrote it when we have brake for make/render scenes.     -- --
 -- --   This script is very helpful to people who aren't know much about    -- --
 -- --     some fucntions of this very good program, witch is named:         -- --
 -- --     3D Studio MAX... :)                                               -- --
 -- --   Why we calling this script "pack"? Simply it was created by         -- --
 -- --     conneting very simple scripts!                                    -- --
 -- --                                                                       -- --
 -- --------------------------------------------------------------------------- --
 
 --                   DON'T CHANGE ANYTHING IN THIS SCRIPT!!!

 -- ==============================================================================
 -- Short in polish:                      |Krotko po polsku:
 -- To jest nasz pierwszys skrypt, a nazwany zostal "pack"'iem dlatgo, ze jest 
 -- zlepkiem kilku malych skryptow:
 -- # Mozesz zresetowac scene, bez pytan ze strony programu; 
 -- # Buduje ziemie, mgle  i mamere za jednym przyciskiem...
 -- # Mozesz uzyskac informacje o wersji 3D Studio, oraz o trybie renderowania
 --   (sieciowy, czy nie)
 -- # Za pomoca dwoczh przyciskow mozesz zapisywac/ladowac wszystkie
 --    tryby plkiow obslugiwane przez MAX'a, tzn. nie potrzebujesz juz przycisku 
 --    "import" do '*.3ds' i "load" do '*.max'...
 -- # NAJLEPSZA RZECZ: Mozesz ladowac plug-iny gdy program jest uruchomiony!!!
 -- # Mozesz wyjsc z menu. :)
 -- Skrypt jest przydanty raczej dla tych, co zbyt dobrze nie znaja programu, ale
 --    innym tez moze sie przydac...
 -- ==============================================================================

 -- Commentarry is not going to tell you anything! :)
 
-- # Begin: script 

macroScript incognizepack1 category:"incognize scripts" tooltip:"incognize script pack #1"
Icon:#("Systems",3) 
( 

-- # PraPrepare: --==I*N*T*E*R*F*A*C*E==--
global newf

-- # Prepare: --==INTERFACE==--
if newf != undefined then closerolloutfloater newf
newf = newRolloutFloater "incognize script pack #1" 350 500

-- # Prepare: RoLlOuTs

rollout scriptpack_buttons "'For good start' buttons" -- For good start...
(
button Reset "Reset Scene, start new" width:145 across:2 align:#center tooltip:"Warning! This button resets the scene without asking!"
 on Reset pressed do 
 (
  resetMaxFile #noPrompt
  MessageBox "Done!" title:"incognize script pack #1"
 )
button sscene "Build ground & atmosphere" width:145 align:#center tooltip:"Very, very simple..."
 on sscene pressed do 
  (  
  -- Adding: atmosphere
   addAtmospheric (Fog ())
  (getAtmospheric 1).Fog_Type = 1
  (getAtmospheric 1).Density = 25
  (getAtmospheric 1).Top = 50
  (getAtmospheric 1).Horizon_Noise = 1
  (getAtmospheric 1).Fog_Color = color 200 200 200
  
  -- Adding: ground
  grnd = (Plane typeInLength:500 typeInWidth:500 length:500 width:500 length_segments:75 width_segments:75 pos:[0,0,0] isSelected:on)
  grndnoise = (noisemodifier seed:(random 1 12345) scale:25 strength:[10,10,10])
  addmodifier grnd grndnoise
  
  -- Adding: camera
  Targetcamera fov:45 nearclip:1 farclip:1000 nearrange:0 farrange:1000 transform:(matrix3 [1,0,0] [0,0,1] [0,-1,0] [150.0,150.0,150.0]) isSelected:on target:(Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]))

  -- Done
  MessageBox "Adding base ground & atmosphere is done." title:"incognize script pack #1"
  )
label scriptpack_start01 "Those are buttons for good start. One resets the scene whithout" align:#left
label scriptpack_start02 "asking, and the second creates simply: ground, fog and camera." align:#left  
) 

-- Save/load/check_file - nothing to add...
rollout scriptpack_system "Main"
(
group "Save(export)/load(import)"
 (
  label scriptpack_sl "Remember about the extension (as '.max' or '.3ds') !" align:#left
  edittext savef "File:" text:"C:\\" across:2 align:#left fieldwidth:245
  button browse_s "B" align:#right width:20 tooltip:"Browse for file" 
  button saveb "Save/export file" width:145 across:2 aling:#left tooltip:"Save the file"
  button chckb "Load/import file" width:145 tooltip:"Load the file"
  checkbox prompti "Prompt when exporting a file (export options)" checked:False
 )  
on browse_s pressed do 
(
patch_s = getOpenFileName caption:"Select file to save(export)/load(import) - incognize script pack #1" types:"3D Studio MAX files (*.max)|*.max|IMPORT/EXPORT - 3D Studio (*.3ds; *.prj)|*.3ds; *.prj|IMPORT/EXPORT - 3D Studio shape (*.shp)|*.shp|IMPORT/EXPORT - AutoCAD (*.dxg; *.dwg)|*.dxg; *.dwg|IMPORT/EXPORT - VRML (*.wrl; *.wlz)|*.wrl; *.wlz|All supported types|*.max; *.3ds; *.prj; *.shp; *.dxg; *.dwg; *.wrl; *.wlz|All files (*.*)|*.*"
if patch_s != undefined then savef.text = patch_s as string
)
on saveb pressed do 
(
 if ((findstring savef.text ".3ds") != undefined) or ((findstring savef.text ".prj") != undefined) or ((findstring savef.text ".dxg") != undefined) or ((findstring savef.text ".dwg") != undefined) or ((findstring savef.text ".shp") != undefined) or ((findstring savef.text ".wrl") != undefined) or ((findstring savef.text ".wlz") != undefined) then
  (
   if (getAppData) == undefined then (messageBox "There is nothing to export!" title:"incognize script pack #1")
    else
	 (
      if prompti.checked then (exportFile savef.text)
	   else (exportFile savef.text #noPrompt)
      (messageBox "File exported!" title:"incognize script pack #1")
	 )
  )
   else
    (
     saveMaxFile savef.text
     (messageBox "File saved!" title:"incognize script pack #1")
	) 
)
on chckb pressed do 
(
 if ((findstring savef.text ".3ds") != undefined) or ((findstring savef.text ".prj") != undefined) or ((findstring savef.text ".dxg") != undefined) or ((findstring savef.text ".dwg") != undefined) or ((findstring savef.text ".shp") != undefined) or ((findstring savef.text ".wrl") != undefined) or ((findstring savef.text ".wlz") != undefined) then
  (
   if (importfile savef.text #noprompt) then (messageBox "File exist, and imported!" title:"incognize script pack #1")
     else (messageBox "File not exist!" title:"incognize script pack #1")
  )
  else
   (
    if (loadMaxFile savef.text) then (messageBox "File exist, and loaded!" title:"incognize script pack #1")
     else (messageBox "File not exist! Try adding '.max' extension!" title:"incognize script pack #1")
   )
)
--  General informations about 3DSMAX
group "General MAX information"
 (
  label scriptpack_general "Press the buttons below to check the:" align:#left
  button netb "Rendering mode" across:2 aling:#left tooltip:"Check the rendering mode"
  button verb "Version of 3D Studio MAX" tooltip:"Check the version of 3D Studio MAX"
  label scriptpack_ver "The version of MAX is: --==UNKNOWN==--" align:#center  
 )  
on netb pressed do
 (
  if (IsNetServer()) then (messageBox "3D Studio MAX is working in network rendering mode." title:"incognize script pack #1")
   else (messageBox "3D Studio MAX is working in normal (non-network) rendering mode!" title:"incognize script pack #1")
 )
on verb pressed do
 (
  version = maxVersion()
  ver1 = version[1]
  ver2 = version[2]
  ver3 = version[3]
  edit "log_ver.txt"
  clearListener()
  print "The MAX version is:"
  print ver1
  print "The max API version is:"
  print ver2
  print "Revision number of SDK:"
  print ver3
  scriptpack_ver.text = "The version of MAX is: " + ver1 as string + "." + ver2 as string + "." + ver3 as string
  messageBox "Press F11 to see more informations about version." title:"incognize script pack #1"
 )
 
-- Load plug-ins/clear memory(from textures) 
group "Memory (plug-ins/textures)" 
 (
  edittext plugs "Patch:" text:"C:\\3DSMAX3\\plugins\\" across:2 align:#left fieldwidth:235
  button browse_p "B" align:#right width:20 tooltip:"Browse for directory to load plug-ins from it"
  label scriptpack_plugs01 "Press 'Load Plug-ins' button to load the plug-ins from directory" align:#left
  label scriptpack_plugs02 "specified in the textbox 'Patch'..." across:2 align:#left
  button loadplugs "Load Plug-ins" tooltip:"Load Plug-ins"
  label scriptpack_plugs03 "" align:#left
  label scriptpack_mem01 "If your computer, and 3DS MAX is running slowly, then press this" align:#left
  label scriptpack_mem02 "button. It clears the memory from image file bitmaps caches." align:#left
  button clearmem "Clear memory"  tooltip:"Press it!"
 )
 on browse_p pressed do 
 (
 local dir = getSavePath caption: "Select the directory to load plug-ins from it:"
   if dir != undefined then plugs.text = dir as string + "\\"
 )

  -- BEST THING!!!
 on loadplugs pressed do 
 (
 loadDllsFromDir plugs.text "*.*"
 MessageBox "Plugins (if there was any) loaded!" title:"incognize script pack #1"
 )
 on clearmem pressed do 
 (
 freeSceneBitmaps()
 MessageBox "Done!" title:"incognize script pack #1"
 )
)
 
-- About...
rollout scriptpack_abouts "About scriptpack #1 & incognize"
(
label scriptpack_label01 "'incognize script pack #1'"
label scriptpack_label03 "by incognize"
label scriptpack_label04 ""
label scriptpack_label05 "incognize members:"
label scriptpack_label06 "starlift"
label scriptpack_label07 "starlift@poczta.onet.pl"
label scriptpack_label02 "!Blob! (writer of this script)"
label scriptpack_label08 "blob_incognize@poczta.fm"
-- label scriptpack_label09 ""                            == 
-- label scriptpack_label10 "WWW page:"                   == Our page is not build yet.
-- label scriptpack_label11 " http://www.incognize.hg.pl" ==
label scriptpack_label12 ""
label scriptpack_label13 "Yes, we are POLISH group!"
group "Exit"
 (
  button quit "Exit the SP#1" tooltip:"Don't press it!"
 )
 on quit pressed do 
 (
  if (queryBox "Are you sure?" title:"incognize script pack #1") then (closeRolloutFloater newf)
   else (
         MessageBox "Then don't press this button again! :)" title:"incognize script pack #1"
	   	 

		 -- I was bored, so I do this:
         	 
 		 sleep 0.1
		 scriptpack_label13.text = "yes, we are POLISH group!"
		 sleep 0.1		 
 		 scriptpack_label13.text = "YEs, we are POLISH group!"
		 sleep 0.1
		 scriptpack_label13.text = "YeS, we are POLISH group!"
		 sleep 0.1
		 scriptpack_label13.text = "Yes, We are POLISH group!"
		 sleep 0.1
		 scriptpack_label13.text = "Yes, wE are POLISH group!"
		 sleep 0.1
		 scriptpack_label13.text = "Yes, we Are POLISH group!"
		 sleep 0.1
		 scriptpack_label13.text = "Yes, we aRe POLISH group!"
		 sleep 0.1
		 scriptpack_label13.text = "Yes, we arE POLISH group!"
		 sleep 0.1
		 scriptpack_label13.text = "Yes, we are pOLISH group!"
		 sleep 0.1
		 scriptpack_label13.text = "Yes, we are PoLISH group!"
		 sleep 0.1
		 scriptpack_label13.text = "Yes, we are POlISH group!"
		 sleep 0.1
		 scriptpack_label13.text = "Yes, we are POLiSH group!"
		 sleep 0.1
		 scriptpack_label13.text = "Yes, we are POLIsH group!"
		 sleep 0.1
		 scriptpack_label13.text = "Yes, we are POLISh group!"
		 sleep 0.1
		 scriptpack_label13.text = "Yes, we are POLISH Group!"
		 sleep 0.1		 
		 scriptpack_label13.text = "Yes, we are POLISH gRoup!"
		 sleep 0.1		 
		 scriptpack_label13.text = "Yes, we are POLISH grOup!"
		 sleep 0.1		 
		 scriptpack_label13.text = "Yes, we are POLISH groUp!"
		 sleep 0.1		 
		 scriptpack_label13.text = "Yes, we are POLISH grouP!"
		 sleep 0.1
		 scriptpack_label13.text = "YES, WE ARE POLISH GROUP!"		 
 		 sleep 1
		 scriptpack_label13.text = "Yes, we are POLISH group!"
		 
		 -- :)) Sorry - that I am (!Blob!)... :)))
		)
 )
)

-- # Add: INTERFACE
addrollout scriptpack_buttons newf
addRollout scriptpack_system newf
addRollout scriptpack_abouts newf rolledup:true

-- # All done! 

)

-- "Thats all, folks!" :)
